import * as ts from "typescript";
import { ReferenceType, DeclarationReflection } from "../../models";
import { Context } from "../context";
/**
 * Create a new reference type pointing to the given symbol.
 *
 * @param context  The context object describing the current state the converter is in.
 * @param symbol  The symbol the reference type should point to.
 * @param includeParent  Should the name of the parent be provided within the fallback name?
 * @returns A new reference type instance pointing to the given symbol.
 */
export declare function createReferenceType(context: Context, symbol: ts.Symbol | undefined, includeParent?: boolean): ReferenceType | undefined;
export declare function createReferenceOrDeclarationReflection(context: Context, source: ts.Symbol, target: ts.Symbol): DeclarationReflection | undefined;
