import * as ts from "typescript";
import { Reflection } from "../../models/index";
import { Context } from "../context";
import { ConverterNodeComponent } from "../components";
export declare class BlockConverter extends ConverterNodeComponent<ts.SourceFile | ts.ModuleBlock> {
    /**
     * List of supported TypeScript syntax kinds.
     */
    supports: ts.SyntaxKind[];
    private entryPoints;
    private baseDir;
    initialize(): void;
    /**
     * Analyze the given class declaration node and create a suitable reflection.
     *
     * @param context  The context object describing the current state the converter is in.
     * @param node     The class declaration node that should be analyzed.
     * @return The resulting reflection or NULL.
     */
    convert(context: Context, node: ts.SourceFile | ts.ModuleBlock): Reflection | undefined;
    /**
     * Analyze the given source file node and create a suitable reflection.
     *
     * @param context  The context object describing the current state the converter is in.
     * @param node     The source file node that should be analyzed.
     * @return The resulting reflection or NULL.
     */
    private convertSourceFile;
    private convertExports;
    private convertReExports;
    private getExports;
    private getModuleName;
    private isEntryPoint;
    private normalizeFileName;
}
