import * as ts from "typescript";
import { Reflection } from "../../models/index";
import { Context } from "../context";
import { ConverterNodeComponent } from "../components";
export declare class ObjectLiteralConverter extends ConverterNodeComponent<ts.ObjectLiteralExpression> {
    /**
     * List of supported TypeScript syntax kinds.
     */
    supports: ts.SyntaxKind[];
    /**
     * Analyze the given object literal node and create a suitable reflection.
     *
     * @param context  The context object describing the current state the converter is in.
     * @param node     The object literal node that should be analyzed.
     * @return The resulting reflection or NULL.
     */
    convert(context: Context, node: ts.ObjectLiteralExpression): Reflection;
}
