import { Type } from "./abstract";
/**
 * Represents a mapped type.
 *
 * ```ts
 * { -readonly [K in keyof U]?: Foo }
 * ```
 */
export declare class MappedType extends Type {
    parameter: string;
    parameterType: Type;
    templateType: Type;
    readonlyModifier?: "+" | "-" | undefined;
    optionalModifier?: "+" | "-" | undefined;
    readonly type = "mapped";
    constructor(parameter: string, parameterType: Type, templateType: Type, readonlyModifier?: "+" | "-" | undefined, optionalModifier?: "+" | "-" | undefined);
    clone(): Type;
    equals(other: Type): boolean;
    toString(): string;
}
